package dev.shadowsoffire.apotheosis.potion;

import net.minecraft.world.entity.LivingEntity;
import net.minecraft.client.multiplayer.ClientLevel;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.alchemy.Potion;
import net.minecraft.ChatFormatting;
import net.minecraft.network.chat.Component;
import net.minecraft.world.item.alchemy.PotionUtils;
import net.minecraft.world.item.Items;
import net.minecraftforge.event.entity.player.ItemTooltipEvent;
import java.util.function.Consumer;
import net.minecraftforge.common.MinecraftForge;
import net.minecraft.client.renderer.item.ItemProperties;
import dev.shadowsoffire.apotheosis.Apotheosis;
import net.minecraft.world.item.Item;
import net.minecraftforge.fml.event.lifecycle.FMLClientSetupEvent;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import dev.shadowsoffire.apotheosis.Apoth;
import net.minecraft.world.level.ItemLike;
import net.minecraftforge.client.event.RegisterColorHandlersEvent;

public class PotionModuleClient
{
    @SubscribeEvent
    public static void colors(final RegisterColorHandlersEvent.Item e) {
        e.register((stack, tint) -> (tint == 0) ? -1 : PotionUtils.m_43575_(stack), new ItemLike[] { (ItemLike)Apoth.Items.POTION_CHARM.get() });
    }
    
    @SubscribeEvent
    public static void client(final FMLClientSetupEvent e) {
        e.enqueueWork(() -> ItemProperties.register((Item)Apoth.Items.POTION_CHARM.get(), Apotheosis.loc("enabled"), (stack, level, entity, tint) -> (stack.m_41782_() && stack.m_41783_().m_128471_("charm_enabled")) ? 1.0f : 0.0f));
        MinecraftForge.EVENT_BUS.addListener((Consumer)PotionModuleClient::showBlacklistedPotions);
    }
    
    public static void showBlacklistedPotions(final ItemTooltipEvent e) {
        if (e.getItemStack().m_41720_() == Items.f_42589_) {
            final Potion potion = PotionUtils.m_43579_(e.getItemStack());
            if (!PotionCharmItem.isValidPotion(potion)) {
                e.getToolTip().add(Component.m_237115_("misc.apotheosis.blacklisted_potion").m_130944_(new ChatFormatting[] { ChatFormatting.DARK_GRAY, ChatFormatting.ITALIC }));
            }
        }
    }
}
